<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml" lang="" xml:lang="">
<head>
  <meta charset="utf-8" />
  <meta name="generator" content="pandoc" />
  <meta name="viewport" content="width=device-width, initial-scale=1.0, user-scalable=yes" />
  <title>cool-profile-readme</title>
  <style type="text/css">
      code{white-space: pre-wrap;}
      span.smallcaps{font-variant: small-caps;}
      span.underline{text-decoration: underline;}
      div.column{display: inline-block; vertical-align: top; width: 50%;}
  </style>
</head>
<body>
<h3 id="hi-there">Hi there 👋</h3>
<ul>
<li>🔭 I’m currently working on JS, Python</li>
<li>🌱 I’m currently learning Advanced Typescript &amp; Go</li>
<li>🤔 I’m looking for &amp; am uptodate with Frontend Everything</li>
<li>👯 I’m looking to work with Ambitious Developers</li>
<li>💬 Ask me about Fullstack in Node, Python, and Typescript</li>
<li>📫 How to reach me: google -&gt; ahmadalibaloch</li>
<li>😄 Pronouns: Runner, Chess Player, Abstract, MultiDomain</li>
<li>⚡ Fun fact: Writing a book “The Unlocking”, to grow original humans on earth free from cultural, childhood, family and self imposed locks!</li>
</ul>
<p><strong>Languages and Tools:</strong></p>
<p><code><img height="20" src="https://raw.githubusercontent.com/github/explore/80688e429a7d4ef2fca1e82350fe8e3517d3494d/topics/javascript/javascript.png"></code> <code><img height="20" src="https://raw.githubusercontent.com/github/explore/80688e429a7d4ef2fca1e82350fe8e3517d3494d/topics/python/python.png"></code> <code><img height="20" src="https://raw.githubusercontent.com/github/explore/80688e429a7d4ef2fca1e82350fe8e3517d3494d/topics/typescript/typescript.png"></code> <code><img height="20" src="https://raw.githubusercontent.com/github/explore/80688e429a7d4ef2fca1e82350fe8e3517d3494d/topics/kotlin/kotlin.png"></code> <code><img height="20" src="https://raw.githubusercontent.com/github/explore/80688e429a7d4ef2fca1e82350fe8e3517d3494d/topics/android/android.png"></code> <code><img height="20" src="https://raw.githubusercontent.com/github/explore/80688e429a7d4ef2fca1e82350fe8e3517d3494d/topics/dart/dart.png"></code></p>
<p><a href="https://github.com/ryo-ma/github-profile-trophy"><img src="https://github-profile-trophy.vercel.app/?username=ahmadalibaloch&row=2&column=3" /></a> <img src="https://github-readme-stats.vercel.app/api?username=ahmadalibaloch&count_private=true&include_all_commits=true&show_icons=true" /></p>
<h1 id="ahmadalibaloch-github-personal-website">ahmadalibaloch github personal website</h1>
<p>Link: <a href="https://ahmadalibaloch.github.io/">ahmadalibaloch.github.io</a> ## What kind of technical stack have you used? Among them, which is the one you are good at using?</p>
<blockquote>
<p>Javascript has been at the top for me in all my career (7+ years). In addition, I have experience with Python, .Net and now Node.js (Prisma, GraphQL) for backend development. On frontend, I have experience with React (3 years +) and Angular. I have extensive experience with data visualization (Echarts especially), mapping (open layers), live data stream and trends rendering. The Micro-Frontends solution for a suit of products here at Intech, with shared components, libraries is also the achievement I count.</p>
</blockquote>
<h2 id="do-you-have-any-experience-of-working-with-the-development-team-please-explain-what-role-you-played-in-what-kind-of-team.">Do you have any experience of working with the development team? Please explain what role you played in what kind of team.</h2>
<blockquote>
<p>I joined as Senior Front End Developer here at Intech in a team of 15 people. We followed the two weeks sprints, agile methodology. Overtime when apps were near launch, we customized the agile, to have possibility of adding some issues/bugs during the sprint to the bucket of developers. Each developer was assigned a module which he was responsible for but not limited to. We, as a team were responsible for our micro-service which consisted of backend and frontend of a web app, using a number of services in a bigger platform, hosted in our own cloud using DCOS later migrated to Kubernetes.</p>
</blockquote>
<h2 id="what-is-your-biggest-achievement-in-your-career-if-thats-a-team-achievement-please-explain-what-did-you-contribute-to-in-order-that-the-team-makes-the-achievement.">What is your biggest achievement in your career? If that’s a team achievement, please explain what did you contribute to, in order that the team makes the achievement.</h2>
<blockquote>
<p>I count a goal as an achievement, when it really is complete (like a published app) and beneficial to end users. Creating this platform called Teamplay here at Intech, on top of which we are now creating many applications is a recent two years achievement in my career, as a team. We faced many technical problems to achieve it. We had to replace many technologies after we found some breaking issues. We have created a solution for micro-frontends, that is unique to our use case, there is a single layout in which many apps get mounted on runtime. There are up to 5 teams dependent on the platform. Many independent apps are now being developed dependent on the basic, scalable, maintainable services of this platform.</p>
</blockquote>
<h2 id="please-share-any-personal-output-as-an-engineer.-if-its-an-achievement-related-to-your-work-please-tell-us-to-what-extent-you-were-committed-to-the-achievement-in-details.">Please share any personal output as an engineer. If it’s an achievement related to your work, please tell us to what extent you were committed to the achievement in details.</h2>
<blockquote>
<p>I was assigned the visualizations module and rendering live streams when I joined my recent job at Intech. I created a service extending MQTT web client, working on top of WebSockets, managing connections and resiliency to keep data synced on frontend, that is the core slogan of this platform, NO DATA LOSS. This service is now being used by almost all apps in the suit and I am proud of that well defined structure.</p>
</blockquote>
<p>Apart from that I created a live line trend, which is the main visualization. It has a number of features and controls for interactivity. I created live maps visualization and many other types of charts. I created another, reporting feature using selenium python/google puppeteer, which would send mails to users on scheduled times for dashboards.</p>
<p>There are many side projects for example some native android apps, developed in Kotlin to present data and show ads. There are also some fun projects and other purpose oriented.</p>
<p>To achieve this all, I have to learn outside of office hours and create many POCs, do R&amp;D, which has added a lot to my knowledge. Sometimes I would sit late in office but I like to be pro-active and do/learn things upfront.</p>
<h2 id="if-you-have-any-experience-aside-from-frontend-please-explain-it.-we-would-like-to-know-in-what-area-and-how-far-you-are-familiar-with.">If you have any experience aside from frontend, please explain it. We would like to know, in what area and how far you are familiar with.</h2>
<blockquote>
<p>I also have professional experience as a Native Android developer. I have some interesting apps published on Playstore, they use Google Cloud as backend, cloud functions, cron jobs, and other related services. I have machine learning experience, trained some ML models stored on GC, which filter the data for these apps. With JS, I used .Net on backend, in our previous company, so I have about 4 years of experience with .Net. Python on the backend. I also contribute on stackoverflow and Github whenever I find an opportunity.</p>
</blockquote>
<h2 id="please-explain-it-if-you-have-an-experience-of-using-the-latest-library-or-framework.">Please explain it if you have an experience of using the latest library or framework.</h2>
<blockquote>
<p>If this question is about frontend then of course the framework I am mostly using is React. For my personal apps, I use Angular, with Nrwl which makes it easy for creating libraries and shared components. In React, I am using latest features introduced in current versions of React like Suspence and Lazy loading of course with React Hooks. I am also ready to move to Angular Ivy when it launches for side projects. We recently moved to GraphQL, for our backend, for which we use Prisma on Node.js here at Intech.</p>
</blockquote>
<h2 id="if-you-have-any-experience-of-management-or-lead-please-explain-it.-how-many-people-were-there-in-the-team-what-kind-of-team-you-were-managing">If you have any experience of management or lead, please explain it. (How many people were there in the team? What kind of team you were managing?)</h2>
<blockquote>
<p>Currently I am working as Lead Developer and Technical Product owner. I have a team of 3 people here at Intech, of which two are fresh grads and one experienced. I assign them tasks in sprint, do code reviews, guide if there is any breaking issue or technology selection. The sprint issues are picked from backlog with the help of product owner and scrum master. Apart from work related help, I want to keep my team members motivated and pro-active. Ask them to learn new technologies and we have created a special channel where we share latest findings. Before this I worked as a senior developer where I was also guiding a junior developer, who now owns many of the modules I developed.</p>
</blockquote>
<h2 id="do-you-have-an-experience-of-agile-or-scrum-also-to-what-extent-are-you-familiar-with-team-development-experience-by-agile-software-development">Do you have an experience of agile or scrum? Also, to what extent are you familiar with team development experience by agile software development?</h2>
<blockquote>
<p>I have already explained our mythology in one of above questions on our custom agile, where we need to have some open time for burning issues or bugs as our apps are now live. We follow two week sprints, before a sprint we do sprint planning where developers are assigned tasks and estimates. At the end of sprint we do a small demo and sprint analysis or reporting. I believe we should follow systems and respect people to create a healthy and motivated development environment. To stop disturbance during sprint from external teams, we appoint one of our developers as fire-fighter, and all other teams like delivery team, and data science team, are expected to reach that person for any issue. If it is a small issue, they would resolve it or get in touch with the specific person at a right time.</p>
</blockquote>
<h2 id="if-you-have-your-own-idea-or-strong-thoughts-of-architecture-or-design-regarding-frontend-development-please-tell-us.">If you have your own idea or strong thoughts of architecture or design regarding frontend development, please tell us.</h2>
<blockquote>
<p>I believe in following a best practice and then sticking to it, if there are no breaking issues. Of course we need to be evaluating or approach and technologies, but there should be a known path or strategy well defined, even if it is custom. Front-end development is diverse and has a huge scope in terms of technologies selection. One thing I learnt migrating to Typescript is that if the team is larger then 2 persons, then they must start with Typescript, that helps a lot. Regarding css, use SASS, and proper variables. Regarding core app development, if using React then other technologies like http library and layouts design library (if any) should be well mentioned and known in a team.</p>
</blockquote>
<h2 id="if-you-have-an-experience-of-microservices-software-development-please-tell-us.">If you have an experience of microservices software development, please tell us.</h2>
<blockquote>
<p>Yes, I am responsible for my own docker/service deployment, its maintenance, logs and versioning. I have working knowledge of bash and other needed commands. I use Ubuntu Linux and sometimes Windows.</p>
</blockquote>
<h2 id="please-let-us-know-the-details-of-your-experience-of-developing-spa-pwa-ssr-etc-if-you-have-any.-also-please-let-us-know-how-youve-involved-with-the-architecture-or-design-of-those-if-you-could-answer-specifically-it-would-be-great.">Please let us know the details of your experience of developing SPA, PWA, SSR etc if you have any. Also, please let us know how you’ve involved with the architecture or design of those? If you could answer specifically it would be great.</h2>
<blockquote>
<p>Single Page Applications is the core skill I am working on for the recent years in my career. I have understanding of the issues like OAuth, permissions, sessions, in SPAs development. I have recently created a service worker, for refreshing JWT tokens, that was an interesting learning.</p>
</blockquote>
<h2 id="in-terms-of-product-development-with-the-team-if-you-have-experience-in-improving-performance-scalability-etc-please-describe-it-specifically.-what-kind-of-service-was-it-how-big-the-system-size-was-how-did-you-contribute-to-the-team">In terms of product development with the team, if you have experience in improving performance/ scalability etc, please describe it specifically. What kind of service was it? How big the system size was? How did you contribute to the team?</h2>
<blockquote>
<p>I have two things to share, one on the frontend and another on the backend. When designing a little library consisting of a service for live line trend, I got the challenge to keep data synced in case of network failure and also performance issue when adding play/pause feature. I have to go deep into the date time issues as well make some improvements in the mqtt original library itself for data sync issue. For performance I tricked into updating arrays in background even in paused state but not rendering UI, that solved my issue of play pause very easily. That was a well spent time on something worthy in the future. In our Python (flask) backend application, we faced the problem when scaling, that there were a number of open DB connections, increasing, always killing the db service. Finding the problem was a challenge but tracking from front-end to back-end using divide and conquer yielded the result.</p>
</blockquote>
</body>
</html>
